// TI-HIP (Hide in Picture) Version 2.2
// 2001, Salmonsoft TI Solutions
// Salmon1231@excite.com

#define OPTIMIZE_ROM_CALLS
#define SAVE_SCREEN
#include <tigcclib.h>

short _ti89;

BYTE crypt(const BYTE in, const BOOL mode);
void fileIOError(void);
void fileSizeError(void);
void getPassword(void);
void hide(const char *filename);
BYTE highByte(const short in);
BYTE lowByte(const short in);
void mainDialog(char *filename, short *mode);
short makeShort(const BYTE highbyte, const BYTE lowbyte);
void memError(void);
FILE *openPic(const char *filename);
FILE *openVar(const char *filename, const BOOL mode);
void seek(const char *filename);

BYTE crypt(const BYTE in, const BOOL mode)
{
	register int out;
	if(mode)
	{
		out = in + rand();
		while(out > 255)
			out -= 256;
	}
	else
	{
		out = in - rand();
		while(out < 0)
			out += 256;
	}
	return (BYTE)out;
}

void fileIOError(void)
{
	DlgMessage("ERROR", "File Error or File not Found", BT_OK, BT_NONE);
	exit(0);
}

void fileSizeError(void)
{
	DlgMessage("ERROR", "File too large to be hidden", BT_OK, BT_NONE);
	exit(0);
}

void getPassword(void)
{
	char password[30], stars[30];
	LCD_BUFFER screen;
	register BYTE i;
	register int hashval;
	short character;
	for(i = 0; i < 30; i++)
	{
		password[i] = 0;
		stars[i] = 0;
	}
	LCD_save(screen);
	clrscr();
	for(i = 0; i < 30; )
	{
		MoveTo(0, 0);
		printf("Password: %s  ", stars);
		character = ngetchx();
		if(character == KEY_ENTER)
			break;
		if(character == KEY_BACKSPACE)
		{
			if(i > 0)
			{
				i--;
				password[i] = 0;
				stars[i] = 0;
			}
			continue;
		}
		password[i] = (char)character;
		stars[i] = '*';
		i++;
	}
	LCD_restore(screen);
	hashval = 317;
	for(i = 0; i < 30; i++)
		hashval = 317 * hashval + password[i];
	srand(hashval);
}

void hide(const char *filename)
{
	BYTE *usedspace;
	FILE *pic, *var;
	register short i, offset;
	short picsize, varsize;
	pic = openPic(filename);
	if(pic == NULL)
		fileIOError();
	for(picsize = 0; getc(pic) != EOF; picsize++);
	fclose(pic);
	var = openVar(filename, TRUE);
	if(var == NULL)
		fileIOError();
	for(varsize = 0; getc(var) != EOF; varsize++);
	fclose(var);
	picsize -= 5;
	if(picsize - 2 < varsize)
		fileSizeError();
	usedspace = (BYTE*)malloc(picsize);
	if(usedspace == NULL)
		memError();
	for(i = 0; i < picsize; i++)
		usedspace[i] = 0;
	pic = openPic(filename);
	var = openVar(filename, TRUE);
	getPassword();
	while(usedspace[offset = random(picsize)] == 1);
	fseek(pic, offset + 4, SEEK_SET);
	putc(highByte(varsize), pic);
	usedspace[offset] = 1;
	while(usedspace[offset = random(picsize)] == 1);
	fseek(pic, offset + 4, SEEK_SET);
	putc(lowByte(varsize), pic);
	usedspace[offset] = 1;
	for(i = 0; i < varsize; i++)
	{
		while(usedspace[offset = random(picsize)]);
		fseek(pic, offset + 4, SEEK_SET);
		putc(crypt(getc(var), TRUE), pic);
		usedspace[offset] = 1;
	}
	fclose(pic);
	fclose(var);
}

BYTE highByte(const short in)
{
	return (BYTE)((in - in % 256) / 256);
}

BYTE lowByte(const short in)
{
	return (BYTE)(in % 256);
}

void mainDialog(char *filename, short *mode)
{
	HANDLE dialog, menu;
	short status;
	menu = PopupNew(NULL, 0);
	if(menu == H_NULL)
		exit(0);
	menu = PopupAddText(menu, -1, "Hide to PIC", 1);
	if(menu == H_NULL)
		exit(0);
	menu = PopupAddText(menu, -1, "Retrieve from PIC", 2);
	if(menu == H_NULL)
		exit(0);
	dialog = DialogNewSimple(150, 90);
	if(dialog == H_NULL)
		exit(0);
	dialog = DialogAddTitle(dialog, "TI-HIP (Hide in Picture) Version 2.2", BT_OK, BT_CANCEL);
	if(dialog == H_NULL)
		exit(0);
	dialog = DialogAddPulldown(dialog, 10, 20, "Mode:", menu, 0);
	if(dialog == H_NULL)
		exit(0);
	dialog = DialogAddRequest(dialog, 10, 30, "Variable Filename:", 0, 17, 9);
	if(dialog == H_NULL)
		exit(0);
	dialog = DialogAddRequest(dialog, 10, 40, "Picture Filename :", 18, 17, 9);
	if(dialog == H_NULL)
		exit(0);
	dialog = DialogAddText(dialog, 10, 50, "2001, Salmonsoft TI Solutions");
	if(dialog == H_NULL)
		exit(0);
	dialog = DialogAddText(dialog, 10, 60, "Salmon1231@excite.com");
	if(dialog == H_NULL)
		exit(0);
	status = DialogDo(dialog, CENTER, CENTER, filename, mode);
	if(status == KEY_ESC)
		exit(0);
}

short makeShort(const BYTE highbyte, const BYTE lowbyte)
{
	return highbyte * 256 + lowbyte;
}

void memError(void)
{
	DlgMessage("ERROR", "Out of Memory", BT_OK, BT_NONE);
	exit(0);
}

FILE *openPic(const char *filename)
{
	FILE *pic;
	pic = fopen(filename + 18, "r+b");
	if(pic == NULL)
		return NULL;
	fseek(pic, 0, SEEK_SET);
	if(getc(pic) != 0)
		return NULL;
	if(getc(pic) > 103)
		return NULL;
	if(getc(pic) != 0)
		return NULL;
	if(getc(pic) > 239)
		return NULL;
	fseek(pic, -1, SEEK_END);
	if(getc(pic) != 223)
		return NULL;
	fseek(pic, 0, SEEK_SET);
	return pic;
}

FILE *openVar(const char *filename, const BOOL mode)
{
	FILE *var;
	if(mode)
		var = fopen(filename, "rb");
	else
		var = fopen(filename, "wb");
	if(var == NULL)
		return NULL;
	return var;
}

void seek(const char *filename)
{
	BYTE highbyte, lowbyte, *usedspace;
	FILE *pic, *var;
	register short i, offset;
	short picsize, varsize;
	pic = openPic(filename);
	if(pic == NULL)
		fileIOError();
	for(picsize = 0; getc(pic) != EOF; picsize++);
	fclose(pic);
	picsize -= 5;
	usedspace = (BYTE*)malloc(picsize);
	if(usedspace == NULL)
		memError();
	for(i = 0; i < picsize; i++)
		usedspace[i] = 0;
	pic = openPic(filename);
	getPassword();
	while(usedspace[offset = random(picsize)]);
	fseek(pic, offset + 4, SEEK_SET);
	highbyte = getc(pic);
	usedspace[offset] = TRUE;
	while(usedspace[offset = random(picsize)]);
	fseek(pic, offset + 4, SEEK_SET);
	lowbyte = getc(pic);
	usedspace[offset] = TRUE;
	varsize = makeShort(highbyte, lowbyte);
	if(picsize - 2 < varsize)
	{
		fclose(pic);
		fileIOError();
	}
	var = openVar(filename, FALSE);
	if(var == NULL)
	{
		fclose(pic);
		fileIOError();
	}
	for(i = 0; i < varsize; i++)
	{
		while(usedspace[offset = random(picsize)] == 1);
		fseek(pic, offset + 4, SEEK_SET);
		putc(crypt(getc(pic), FALSE), var);
		usedspace[offset] = 1;
	}
	fclose(pic);
	fclose(var);
}

void _main(void)
{
	char filename[36];
	register BYTE i;
	short mode[1];
	for(i = 0; i < 36; i++)
		filename[i] = 0;
	mode[0] = 1;
	mainDialog(filename, mode);
	if(mode[0] == 1)
		hide(filename);
	if(mode[0] == 2)
		seek(filename);
}
